package com.csc.library.properties;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Serializable;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

public class JsonFileImpl implements JsonFile , Serializable{
	private String dirName;
	private String fileName;
	private transient ByteBuffer buffer;
	private byte[] bytes;
	
	public JsonFileImpl(File file) throws Exception{
		if(file == null){
			throw new NullPointerException();
		}else if(!file.exists()){
			throw new FileNotFoundException();
		}else if(!file.isFile()){
			throw new Exception("UploadProperties accept File Only. cannot load Directory");
		}
		this.dirName = file.getPath();
		this.fileName = file.getName();
		this.readFile(file);
	}
	
	public JsonFileImpl(File file , String dirName , String fileName) throws Exception{
		if(file == null){
			throw new NullPointerException();
		}else if(!file.exists()){
			throw new FileNotFoundException();
		}else if(!file.isFile()){
			throw new Exception("UploadProperties accept File Only. cannot load Directory");
		}
		this.dirName = dirName;
		this.fileName = fileName;
		this.readFile(file);
	}
	
	public JsonFileImpl(byte[] bytes , String dirName , String fileName) throws Exception{
		this.dirName = dirName;
		this.fileName = fileName;
		this.bytes = bytes;
	}
	
	protected void readBytes(byte[] bytes){
		buffer = ByteBuffer.allocate(bytes.length);
		buffer.put(bytes);
	}
	
	protected void readFile(File file) throws IOException{
		FileInputStream fIn = new FileInputStream(file);
	    FileChannel fChan = fIn.getChannel();
    	buffer = ByteBuffer.allocate((int) fChan.size());
    	fChan.read(buffer);
    	fChan.close();
    	fIn.close();
    	this.bytes = buffer.array();
	}
	
	public void writeFile(String path) throws IOException{
		if( bytes != null) {
			FileOutputStream out = new FileOutputStream(path , false);
			FileChannel channel = out.getChannel();
			buffer = ByteBuffer.allocate(bytes.length);
			buffer.put(bytes);
			buffer.flip();
			channel.write(buffer);
			channel.close();
			out.close();
		}
	}
	
	public String getPath(){
		return "";
	}
	
	public String getFileName(){
		return this.fileName;
	}

	@Override
	public String getDirectory() {
		return this.dirName;
	}
	
	public byte[] getBytes(){
		return this.bytes;
	}
}
